// DGComm.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "DGComm.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

//Variable global
BOOL AN_stat[32]; // true si le CRC a t calcul
unsigned int AN[32]; //Stocke ici toutes les valeurs des entres analogiques

// Variable exporte
DGCOMM_API unsigned int AN_ext[32]; //Stocke ici toutes les valeurs des entres analogiques export


DGCOMM_API HANDLE OpenDGComm(char *pszCom)
{
	HANDLE cf;  // numro du port de communication ouvert
	
	
	// Ouvre le port srie
	cf = CreateFile(pszCom, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING,
                 0, NULL);
	
	if (!cf) // Si erreur lors de l'ouverture
	{
		char buf[100];
		wsprintf(buf, "Impossible d'ouvrir %s", pszCom);
		MessageBox(NULL,buf,NULL,MB_OK);
	}
	else
	{
	
		// spcifie les paramtres de la ligne
		static DCB dcb;
  		GetCommState(cf,&dcb);
			dcb.BaudRate = CBR_115200; // Vitesse de transmission 115200 bauds
			dcb.Parity = NOPARITY; // pas de parit
			dcb.ByteSize = 8; // 8 bitd
			dcb.StopBits = ONESTOPBIT; // 1 bit de stop
			dcb.fAbortOnError = FALSE; // si une erreur on continue la communication
		SetCommState(cf, &dcb);
	}
	
	return 	cf; // renvoie le numro

}

void crccheck(char No,unsigned char CRC) {
	if( (No+1+AN[No])%255!=CRC) // effectue le CRC
		AN[No]=0; // si mauvais on met le canal en erreur
	AN_stat[No]=true;
}

DGCOMM_API int ReadDGComm(HANDLE cf)
{
	
	unsigned char buf[10000]; // antmmoire pour stocker les donnes provisoirement
 
	DWORD nbRead;	  // Variable de contrle du port srie
	DWORD ErrorMask; 
	COMSTAT comstat;

	unsigned char ANx=255;			// Valeur en cours de lecture

	for(unsigned int i=0;i<32; i++)
		AN_stat[i]=false;

	// 50 fois par seconde, voit si des caractres ont t reus
	ClearCommError(cf, &ErrorMask, &comstat); // efface les erreur eventuelle reu
    ReadFile(cf, &buf, comstat.cbInQue, &nbRead, NULL); // lit le buffer du port srie
    
	for (i=0; i<nbRead; i++)
    {
		// Rcupre la valeur du canaux entrain d'tre lu
		if(buf[i]==',') // regarde si on a une virgule 
			if((i-1) >0) {
				switch(buf[i-1])
				{
					case 1 :
						ANx=0;
						AN[0]=0;
					break;
					case 2 :
						ANx=1;
						AN[1]=0;
					break;
					case 3 :
						ANx=2;
						AN[2]=0;
					break;
					case 4 :
						ANx=3;
						AN[3]=0;
					break;
					case 5 :
						ANx=4;
						AN[4]=0;
					break;
					case 6 :
						ANx=5;
						AN[5]=0;
					break;
					case 7 :
						ANx=6;
						AN[6]=0;
					break;
					case 8 :
						ANx=7;
						AN[7]=0;
					break;
					case 9 :
						ANx=8;
						AN[8]=0;
					break;
					case 10 :
						ANx=9;
						AN[9]=0;
					break;
					case 11 :
						ANx=10;
						AN[10]=0;
					break;
					case 12 :
						ANx=11;
						AN[11]=0;
					break;
					case 13:
						ANx=12;
						AN[12]=0;
					break;
					case 14 :
						ANx=13;
						AN[13]=0;
					break;
					case 15 :
						ANx=14;
						AN[14]=0;
					break;
					case 16 :
						ANx=15;
						AN[15]=0;
					case 17 :
						ANx=16;
						AN[16]=0;
					break;
					case 18 :
						ANx=17;
						AN[17]=0;
					break;
					case 19 :
						ANx=18;
						AN[18]=0;
					break;
					case 20 :
						ANx=19;
						AN[19]=0;
					break;
					case 21 :
						ANx=20;
						AN[20]=0;
					break;
					case 22 :
						ANx=21;
						AN[21]=0;
					break;
					case 23 :
						ANx=22;
						AN[22]=0;
					break;
					case 24 :
						ANx=23;
						AN[23]=0;
					break;
					case 25 :
						ANx=24;
						AN[24]=0;
					break;
					case 26 :
						ANx=25;
						AN[25]=0;
					break;
					case 27 :
						ANx=26;
						AN[26]=0;
					break;
					case 28 :
						ANx=27;
						AN[27]=0;
					break;
					case 29:
						ANx=28;
						AN[28]=0;
					break;
					case 30 :
						ANx=29;
						AN[29]=0;
					break;
					case 31 :
						ANx=30;
						AN[30]=0;
					break;
					case 32 :
						ANx=31;
						AN[31]=0;
					break;
				}
			}
		
		// Rcupre les valeurs des diffrents canaux
		if(ANx!=255 && buf[i]!=',') {
				switch(ANx)
				{
					case 0:
						if(buf[i+1]!=0)
							AN[0]=AN[0]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(0,buf[i]);
						    ANx=255;
						}
					break;
					case 1:
						if(buf[i+1]!=0)
							AN[1]=AN[1]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(1,buf[i]);
						    ANx=255;
						}
					break;
					case 2:
						if(buf[i+1]!=0)
							AN[2]=AN[2]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(2,buf[i]);
						    ANx=255;
						}
					break;
					case 3:
						if(buf[i+1]!=0)
							AN[3]=AN[3]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(3,buf[i]);
							ANx=255;
						}	
					break;
					case 4:
						if(buf[i+1]!=0)
							AN[4]=AN[4]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(4,buf[i]);
						    ANx=255;
						}
					break;
					case 5:
						if(buf[i+1]!=0)
							AN[5]=AN[5]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(5,buf[i]);
						    ANx=255;
						}
					break;
					case 6:
						if(buf[i+1]!=0)
							AN[6]=AN[6]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(6,buf[i]);
						    ANx=255;
						}
					break;
					case 7:
						if(buf[i+1]!=0)
							AN[7]=AN[7]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(7,buf[i]);
						    ANx=255;
						}
					break;
					case 8:
						if(buf[i+1]!=0)
							AN[8]=AN[8]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(8,buf[i]);
						    ANx=255;
						}
					break;
					case 9:
						if(buf[i+1]!=0)
							AN[9]=AN[9]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(9,buf[i]);
						    ANx=255;
						}
					break;
					case 10:
						if(buf[i+1]!=0)
							AN[10]=AN[10]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(10,buf[i]);
						    ANx=255;
						}
					break;
					case 11:
						if(buf[i+1]!=0)
							AN[11]=AN[11]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(11,buf[i]);
						    ANx=255;
						}
					break;
					case 12:
						if(buf[i+1]!=0)
							AN[12]=AN[12]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(12,buf[i]);
						    ANx=255;
						}
					break;
					case 13:
						if(buf[i+1]!=0)
							AN[13]=AN[13]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(13,buf[i]);
						    ANx=255;
						}
					break;
					case 14:
						if(buf[i+1]!=0)
							AN[14]=AN[14]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(14,buf[i]);
						    ANx=255;
						}
					break;
					case 15:
						if(buf[i+1]!=0)
							AN[15]=AN[15]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(15,buf[i]);
						    ANx=255;
						}
					break;
					case 16:
						if(buf[i+1]!=0)
							AN[16]=AN[16]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(16,buf[i]);
						    ANx=255;
						}
					break;
					case 17:
						if(buf[i+1]!=0)
							AN[17]=AN[17]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(17,buf[i]);
						    ANx=255;
						}
					break;
					case 18:
						if(buf[i+1]!=0)
							AN[18]=AN[18]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(18,buf[i]);
						    ANx=255;
						}
					break;
					case 19:
						if(buf[i+1]!=0)
							AN[19]=AN[19]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(19,buf[i]);
						    ANx=255;
						}
					break;
					case 20:
						if(buf[i+1]!=0)
							AN[20]=AN[20]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(20,buf[i]);
						    ANx=255;
						}
					break;
					case 21:
						if(buf[i+1]!=0)
							AN[21]=AN[21]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(21,buf[i]);
						    ANx=255;
						}
					break;
					case 22:
						if(buf[i+1]!=0)
							AN[22]=AN[22]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(22,buf[i]);
						    ANx=255;
						}
					break;
					case 23:
						if(buf[i+1]!=0)
							AN[23]=AN[23]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(23,buf[i]);
						    ANx=255;
						}
					break;
					case 24:
						if(buf[i+1]!=0)
							AN[24]=AN[24]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(24,buf[i]);
						    ANx=255;
						}
					break;
					case 25:
						if(buf[i+1]!=0)
							AN[25]=AN[25]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(25,buf[i]);
						    ANx=255;
						}
					break;
					case 26:
						if(buf[i+1]!=0)
							AN[26]=AN[26]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(26,buf[i]);
						    ANx=255;
						}
					break;
					case 27:
						if(buf[i+1]!=0)
							AN[27]=AN[27]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(27,buf[i]);
						    ANx=255;
						}
					break;
					case 28:
						if(buf[i+1]!=0)
							AN[28]=AN[28]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(28,buf[i]);
						    ANx=255;
						}
					break;
					case 29:
						if(buf[i+1]!=0)
							AN[29]=AN[29]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(29,buf[i]);
						    ANx=255;
						}
					break;
					case 30:
						if(buf[i+1]!=0)
							AN[30]=AN[30]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(30,buf[i]);
						    ANx=255;
						}
					break;
					case 31:
						if(buf[i+1]!=0)
							AN[31]=AN[31]*256+buf[i];
						if(buf[i+1]==0) {
						    crccheck(31,buf[i]);
						    ANx=255;
						}
					break;
				}
		}
	}	
	
	// Vrifie si toute les valeurs ont t vrifies
	for(i=0;i<32;i++)
		if(AN_stat[i]==false)
			AN[i]=0;

	// Met les valeurs dans la variable export
	for(i=0;i<32;i++)
		if(AN[i]<1023 && AN[i]>10)
			AN_ext[i]=AN[i];

	// Renvoie le nombre de caractre reu
	return nbRead;
}