// DLL GFX.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "DLL GFX.h"
#include "Load3DS.h"
#include <GL/glut.h>

RECT  g_rRect;										
HDC   g_hDC;										
HGLRC g_hRC;										
HINSTANCE g_hInstance;								

#define FILE_NAME  "hand.3ds"							// Nom du fichier 3DS

UINT g_Texture[MAX_TEXTURES] = {0};						// Stockage des diffrents texture par leur numro ID

CLoad3DS g_Load3ds;					
t3DModel g_3DModel;					

int   g_ViewMode	  = GL_TRIANGLES;	
bool  g_bLighting     = true;			
static int MousePosX, MousePosY, RotationX=40, RotationY=0, RotationZ=0, TranslationX=1, TranslationY=1, TranslationZ;		// Dplacement de la camra
static bool WireFrame, Lumiere, Zoom, Translate, Rotate, BackFace, Texture;
int		SpeedRotX = 10.0;
int		Cam = 1.0;
int		CamX = -3.0, CamY = 1.0, CamZ = 8.0;

// Pour le gestion des 2 fenetres
int winIdMain, winIdSub;
#define TIME_STEP    0.1
static double time = 0.0;
static char label[100];

// Pour la gestion du menu
enum {
  M_NONE, M_WIREFRAME, M_LUMIERE, M_BACKFACE
};


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


// Initlialize la fentre OpenGL
void Init()
{
	g_Load3ds.Import3DS(&g_3DModel, FILE_NAME);			

	for(int i = 0; i < g_3DModel.numOfMaterials; i++)
	{
		if(strlen(g_3DModel.pMaterials[i].strFile) > 0)
		{
			CreateTexture(g_Texture, g_3DModel.pMaterials[i].strFile, i);			
		}

		g_3DModel.pMaterials[i].texureId = i;
	}

	glEnable(GL_LIGHT0);		
	glEnable(GL_LIGHTING);		
	glEnable(GL_COLOR_MATERIAL);						
	
}

void DessinePhalange(int NumPhalange) {
    // Get the current object that we are displaying
	t3DObject *pObject2 = &g_3DModel.pObject[NumPhalange];
			
	// Check to see if this object has a texture map, if so bind the texture to it.
	if(pObject2->bHasTexture) {
		// Turn on texture mapping and turn off color
		glEnable(GL_TEXTURE_2D);
		// Reset the color to normal again
		glColor3ub(255, 255, 255);
		// Bind the texture map to the object by it's materialID
		glBindTexture(GL_TEXTURE_2D, g_Texture[pObject2->materialID]);
	} else {
		// Turn off texture mapping and turn on color
		glDisable(GL_TEXTURE_2D);
		// Reset the color to normal again
		glColor3ub(255, 255, 255);
	}
	
	// This determines if we are in wireframe or normal mode
	glBegin(g_ViewMode);					// Begin drawing with our selected mode (triangles or lines)
	// Go through all of the faces (polygons) of the object and draw them
	for(int j = 0; j < pObject2->numOfFaces; j++)
	{
		// Go through each corner of the triangle and draw it.
		for(int whichVertex = 0; whichVertex < 3; whichVertex++)
		{
			// Get the index for each point of the face
			int index = pObject2->pFaces[j].vertIndex[whichVertex];
				
			// Give OpenGL the normal for this vertex.
			glNormal3f(pObject2->pNormals[ index ].x, pObject2->pNormals[ index ].y, pObject2->pNormals[ index ].z);
				
			// If the object has a texture associated with it, give it a texture coordinate.
			if(pObject2->bHasTexture) {
				// Make sure there was a UVW map applied to the object or else it won't have tex coords.
				if(pObject2->pTexVerts) {
					glTexCoord2f(pObject2->pTexVerts[ index ].x, pObject2->pTexVerts[ index ].y);
				}
			} else {
				// Make sure there is a valid material/color assigned to this object.
				// You should always at least assign a material color to an object, 
				// but just in case we want to check the size of the material list.
				// if the size is at least one, and the material ID != -1,
				// then we have a valid material.
				if(g_3DModel.pMaterials.size() && pObject2->materialID >= 0) 
				{
					// Get and set the color that the object is, since it must not have a texture
					BYTE *pColor = g_3DModel.pMaterials[pObject2->materialID].color;

					// Assign the current color to this model
					glColor3ub(pColor[0], pColor[1], pColor[2]);
				}
			}

			// Pass in the current vertex of the object (Corner of current face)
			glVertex3f(pObject2->pVerts[ index ].x, pObject2->pVerts[ index ].y, pObject2->pVerts[ index ].z);
		}
	}
	glEnd();								// End the drawing		
}

// Calcule la Scne
void display() 
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();									// Reset The matrix

//////////// *** NEW *** ////////// *** NEW *** ///////////// *** NEW *** ////////////////////

	// Give OpenGL our position,	then view,		then up vector
	//gluLookAt(		0, 1.5f, 8,		0, 0.5f, 0,			0, 1, 0);
	gluLookAt(		CamX, CamY, CamZ,		0, 0, 0,			0, 1, 0);

	// Rotation de la camra
	glRotatef(RotationX, 1.0, 0, 0);
	glRotatef(RotationY, 0, 1.0, 0);
	glRotatef(RotationZ, 0, 0, 1.0);
	glTranslatef(TranslationX,TranslationY,TranslationZ);
	//RotationX += SpeedRotX;

/*
// AIDE maTrix
glutWireCube(14);
glutWireCube(7);
glutWireCube(6);
glutWireCube(5);
glutWireCube(4);
glutWireCube(3);
glutWireCube(2);
glutWireCube(1);
//fin aide Matrix
*/

// poignet
//DessinePhalange(0);
	glTranslatef(0, 0, 4.0);
	glRotatef(g_3DModel.pObject[0].angle.x, 1.0, 0, 0);
	glRotatef(g_3DModel.pObject[0].angle.y, 0, 1.0, 0);
	glRotatef(g_3DModel.pObject[0].angle.z, 0, 0, 1.0);
	glTranslatef(0, 0, -4.0);
	glPushMatrix();
		DessinePhalange(0);
	glPopMatrix();

// metacarpes
	DessinePhalange(4);
	DessinePhalange(8);
	DessinePhalange(12);
	DessinePhalange(16);

// pouce
	glPushMatrix();
		// Fat tourner les doigts autour de leurs axes	
		glTranslatef(-0.9, -0.2, 3);
		glRotatef(g_3DModel.pObject[1].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[1].angle.y, 0, 1.0, 0);
		glTranslatef(0.9, 0.2, -3);
		glPushMatrix();
			DessinePhalange(1);
		glPopMatrix();
	
		glTranslatef(-1.86, -0.35, 1.45);
		glRotatef(g_3DModel.pObject[2].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[2].angle.y, 0, 1.0, 0);
		glTranslatef(1.86, 0.35, -1.45);
		glPushMatrix();
			DessinePhalange(2);
		glPopMatrix();

		glTranslatef(-2.09, -0.43, 0.27);
		glRotatef(g_3DModel.pObject[3].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[3].angle.y, 0, 1.0, 0);
		glTranslatef(2.09, 0.43, -0.27);
		glPushMatrix();
			DessinePhalange(3);
		glPopMatrix();
	glPopMatrix();

// index
	glPushMatrix();
		// Fat tourner les doigts autour de leurs axes	
		glTranslatef(-0.7, 0, 0);
		glRotatef(g_3DModel.pObject[5].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[5].angle.y, 0, 1.0, 0);
		glTranslatef(0.7, 0, 0);
		glPushMatrix();
			DessinePhalange(5);
		glPopMatrix();
	
		glTranslatef(-0.9, 0, -1.46);
		glRotatef(g_3DModel.pObject[6].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[6].angle.y, 0, 1.0, 0);
		glTranslatef(0.9, 0, 1.46);
		glPushMatrix();
			DessinePhalange(6);
		glPopMatrix();

		glTranslatef(-0.97, -0.3, -2.27);
		glRotatef(g_3DModel.pObject[7].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[7].angle.y, 0, 1.0, 0);
		glTranslatef(0.97, 0.3, 2.27);
		glPushMatrix();
			DessinePhalange(7);
		glPopMatrix();
	glPopMatrix();

// majeur
	glPushMatrix();
		// Fat tourner les doigts autour de leurs axes	
		glTranslatef(0, 0, 0);
		glRotatef(g_3DModel.pObject[9].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[9].angle.y, 0, 1.0, 0);
		glTranslatef(0, 0, 0);
		glPushMatrix();
			DessinePhalange(9);
		glPopMatrix();
	
		glTranslatef(0, 0, -1.85);
		glRotatef(g_3DModel.pObject[10].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[10].angle.y, 0, 1.0, 0);
		glTranslatef(0, 0, 1.85);
		glPushMatrix();
			DessinePhalange(10);
		glPopMatrix();

		glTranslatef(-0.1, -0.27, -2.86);
		glRotatef(g_3DModel.pObject[11].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[11].angle.y, 0, 1.0, 0);
		glTranslatef(0.1, 0.27, 2.86);
		glPushMatrix();
			DessinePhalange(11);
		glPopMatrix();
	glPopMatrix();

// annulaire
	glPushMatrix();
		// Fat tourner les doigts autour de leurs axes	
		glTranslatef(0.65, 0, 0);
		glRotatef(g_3DModel.pObject[13].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[13].angle.y, 0, 1.0, 0);
		glTranslatef(-0.65, 0, 0);
		glPushMatrix();
			DessinePhalange(13);
		glPopMatrix();
	
		glTranslatef(0.86, 0, -1.65);
		glRotatef(g_3DModel.pObject[14].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[14].angle.y, 0, 1.0, 0);
		glTranslatef(-0.86, 0, 1.65);
		glPushMatrix();
			DessinePhalange(14);
		glPopMatrix();

		glTranslatef(0.78, -0.27, -2.65);
		glRotatef(g_3DModel.pObject[15].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[15].angle.y, 0, 1.0, 0);
		glTranslatef(-0.78, 0.27, 2.65);
		glPushMatrix();
			DessinePhalange(15);
		glPopMatrix();
	glPopMatrix();

// oriculaire
	glPushMatrix();
		// Fat tourner les doigts autour de leurs axes	
		glTranslatef(1.22, 0, 0.45);	
		glRotatef(g_3DModel.pObject[17].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[17].angle.y, 0, 1.0, 0);
		glTranslatef(-1.22, 0, -0.45);
		glPushMatrix();
			DessinePhalange(17);
		glPopMatrix();
	
		glTranslatef(1.5, 0, -0.77);
		glRotatef(g_3DModel.pObject[18].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[18].angle.y, 0, 1.0, 0);
		glTranslatef(-1.5, 0, 0.77);
		glPushMatrix();
			DessinePhalange(18);
		glPopMatrix();

		glTranslatef(1.48, -0.23, -1.58);
		glRotatef(g_3DModel.pObject[19].angle.x, 1.0, 0, 0);
		glRotatef(g_3DModel.pObject[19].angle.y, 0, 1.0, 0);
		glTranslatef(-1.48, 0.23, 1.58);
		glPushMatrix();
			DessinePhalange(19);
		glPopMatrix();
	glPopMatrix();

	glFlush();
	glutSwapBuffers();
}

///////////////////////////////// WIN PROC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	This function handles the window messages.
/////
///////////////////////////////// WIN PROC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*

void key(unsigned char Key, int x, int y) 
{
/* Definition des controls

-----------------------------------------------------------------
index des touches utilises :
-----------------------------------------------------------------
Doigt		sens	proximal	middle	distal	pivot	Abduction
-----------------------------------------------------------------
poignet		-		*			*		*		y/h/n
pognet		+		*			*		*		Y/H/N
pouce		-		a			q		w		,		---		
pouce		+		A			Q		W		?		---
index		-		z			s		x		k
index		+		Z			S		X		K
majeur		-		e			d		c		o
majeur		+		E			D		C		O
annulaire	-		r			f		v		p
annulaire	+		R			F		V		P
oriculaire	-		t			g		b		m
oriculaire	+		T			G		B		M
-----------------------------------------------------------------

-----------------------------------------------------------------
Options
-----------------------------------------------------------------
Touche				Fonction
-----------------------------------------------------------------
Clic souris droit	mode fil de fer (on/off)
-----------------------------------------------------------------

-----------------------------------------------------------------
Orientation de la camra
-----------------------------------------------------------------
Touche	Fonction
-----------------------------------------------------------------
1		--
2		bas
3		zoom out
4		gauche
5		
6		droite
7		--
8		haut
9		zoom ininit
+		rotation +
-		rotation -
-----------------------------------------------------------------

*/

		switch (Key) {

			//mouvements de bases sur la scene [rotation/translation] 
			//**** modifier via glLooAt() par la suite !****//
			case '+':
				RotationX += SpeedRotX;
			break;

			case '-':
				RotationX -= SpeedRotX;
			break;

			case '3':
				CamZ += Cam;
			break;

			case '9':
				CamZ -= Cam;
			break;
			
			case '6':
				CamX += Cam;
			break;

			case '4':
				CamX -= Cam;
			break;

			case '2':
				CamY -= Cam;
			break;

			case '8':
				CamY += Cam;
			break;

			case '5':
				CamX = -3;
				CamY = 1;
				CamZ = 8;
			break;

			// ********* Gestion des contraintes sur la main *************
			// Poignet
				//Pivot
			case 'y':
				if (g_3DModel.pObject[0].angle.x > -90) 
					g_3DModel.pObject[0].angle.x -= 5;
				break;
			case 'Y':
				if (g_3DModel.pObject[0].angle.x < 90) 
					g_3DModel.pObject[0].angle.x += 5;
				break;
			case 'h':
				if (g_3DModel.pObject[0].angle.y > -45)
					g_3DModel.pObject[0].angle.y -= 5;
				break;
			case 'H':
				if (g_3DModel.pObject[0].angle.y < 45)
					g_3DModel.pObject[0].angle.y += 5;
				break;
			case 'n':
				if (g_3DModel.pObject[0].angle.z > -45)
					g_3DModel.pObject[0].angle.z -= 5;
				break;
			case 'N':
				if (g_3DModel.pObject[0].angle.z < 45)
					g_3DModel.pObject[0].angle.z += 5;
				break;

			// Pouce
				//Flexion -1
			case 'a':
				if (g_3DModel.pObject[1].angle.x > -60) 
					g_3DModel.pObject[1].angle.x -= 5;
				break;
			case 'q':
				if (g_3DModel.pObject[2].angle.y > -60) 
					g_3DModel.pObject[2].angle.y -= 5;
				break;
			case 'w':
				if (g_3DModel.pObject[3].angle.y > -90)
					g_3DModel.pObject[3].angle.y -= 5;
				break;

				//Flexion +1
			case 'A':
				if (g_3DModel.pObject[1].angle.x < 10) 
					g_3DModel.pObject[1].angle.x += 5;
				break;
			case 'Q':
				if (g_3DModel.pObject[2].angle.y < 0)
					g_3DModel.pObject[2].angle.y += 5;
				break;
			case 'W':
				if (g_3DModel.pObject[3].angle.y < 0)
					g_3DModel.pObject[3].angle.y += 5;
				break;

				//Pivot
			case ',':
				if (g_3DModel.pObject[1].angle.y > -60)
					g_3DModel.pObject[1].angle.y -= 1;
				break;

			case '?':
				if (g_3DModel.pObject[1].angle.y < 20)
					g_3DModel.pObject[1].angle.y += 1;
				break;

			// Index
				//Flexion -1
			case 'z':
				if (g_3DModel.pObject[5].angle.x > -90)
					g_3DModel.pObject[5].angle.x -= 5;
				break;
			case 's':
				if (g_3DModel.pObject[6].angle.x > -110)
					g_3DModel.pObject[6].angle.x -= 5;			
				break;
			case 'x':
				if (g_3DModel.pObject[7].angle.x > -90)
					g_3DModel.pObject[7].angle.x -= 5;
				break;

				//Flexion +1
			case 'Z':
				if (g_3DModel.pObject[5].angle.x < 30)
					g_3DModel.pObject[5].angle.x += 5;
				break;
			case 'S':
				if (g_3DModel.pObject[6].angle.x < 0)
					g_3DModel.pObject[6].angle.x += 5;
				break;
			case 'X':
				if (g_3DModel.pObject[7].angle.x < 0)
					g_3DModel.pObject[7].angle.x += 5;
				break;

				//Pivot
			case 'k':
				if (g_3DModel.pObject[5].angle.y > -10)
					g_3DModel.pObject[5].angle.y -= 1;
				break;

			case 'K':
				if (g_3DModel.pObject[5].angle.y < 20)
					g_3DModel.pObject[5].angle.y += 1;
				break;


			// Majeur
				//Flexion -1
			case 'e':
				if (g_3DModel.pObject[9].angle.x > -90)
					g_3DModel.pObject[9].angle.x -= 5;
				break;
			case 'd':
				if (g_3DModel.pObject[10].angle.x > -110)
					g_3DModel.pObject[10].angle.x -= 5;
				break;
			case 'c':
				if (g_3DModel.pObject[11].angle.x > -90)
					g_3DModel.pObject[11].angle.x -= 5;
				break;

				//Flexion +1
			case 'E':
				if (g_3DModel.pObject[9].angle.x < 30)
					g_3DModel.pObject[9].angle.x += 5;
				break;
			case 'D':
				if (g_3DModel.pObject[10].angle.x < 0)
					g_3DModel.pObject[10].angle.x += 5;
				if (g_3DModel.pObject[11].angle.x < 0)
					g_3DModel.pObject[11].angle.x += 5;
				break;
			case 'C':
				if (g_3DModel.pObject[11].angle.x < 0)
					g_3DModel.pObject[11].angle.x += 5;
				break;

				//Pivot
			case 'o':
				if (g_3DModel.pObject[9].angle.y > -15)
					g_3DModel.pObject[9].angle.y -= 1;
				break;

			case 'O':
				if (g_3DModel.pObject[9].angle.y < 15)
					g_3DModel.pObject[9].angle.y += 1;
				break;
	
			// Annulaire
				//Flexion -1
			case 'r':
				if (g_3DModel.pObject[13].angle.x > -90)
					g_3DModel.pObject[13].angle.x -= 5;
				break;
			case 'f':
				if (g_3DModel.pObject[14].angle.x > -110)
					g_3DModel.pObject[14].angle.x -= 5;
				break;
			case 'v':
				if (g_3DModel.pObject[15].angle.x > -90)
					g_3DModel.pObject[15].angle.x -= 5;
				break;

				//Flexion +1
			case 'R':
				if (g_3DModel.pObject[13].angle.x < 30)
					g_3DModel.pObject[13].angle.x += 5;
				break;
			case 'F':
				if (g_3DModel.pObject[14].angle.x < 0)
					g_3DModel.pObject[14].angle.x += 5;
				break;
			case 'V':
				if (g_3DModel.pObject[15].angle.x < 0)
					g_3DModel.pObject[15].angle.x += 5;
				break;

				//Pivot
			case 'p':
				if (g_3DModel.pObject[13].angle.y > -20)
					g_3DModel.pObject[13].angle.y -= 1;
				break;

			case 'P':
				if (g_3DModel.pObject[13].angle.y < 10)
					g_3DModel.pObject[13].angle.y += 1;
				break;

			// Oriculaire
				//Flexion -1
			case 't':
				if (g_3DModel.pObject[17].angle.x > -90)
					g_3DModel.pObject[17].angle.x -= 5;
				break;
			case 'g':
				if (g_3DModel.pObject[18].angle.x > -110)
					g_3DModel.pObject[18].angle.x -= 5;
				break;
			case 'b':
				if (g_3DModel.pObject[19].angle.x > -90)
					g_3DModel.pObject[19].angle.x -= 5;
				break;

				//Flexion +1
			case 'T':
				if (g_3DModel.pObject[17].angle.x < 0)
					g_3DModel.pObject[17].angle.x += 5;
				break;
			case 'G':
				if (g_3DModel.pObject[18].angle.x < 0)
					g_3DModel.pObject[18].angle.x += 5;
				break;
			case 'B':
				if (g_3DModel.pObject[19].angle.x < 0)
					g_3DModel.pObject[19].angle.x += 5;
				break;

				//Pivot
			case 'm':
				if (g_3DModel.pObject[17].angle.y > -40)
					g_3DModel.pObject[17].angle.y -= 1;
				break;

			case 'M':
				if (g_3DModel.pObject[17].angle.y < 10)
					g_3DModel.pObject[17].angle.y += 1;
				break;
			default:
				break;
		}

	glutPostRedisplay();
}

void clic_souris (int button, int state, int x, int y)
{
    int modifier = glutGetModifiers();

	//if (modifier == GLUT_ACTIVE_SHIFT)
	//if (modifier == GLUT_ACTIVE_CTRL)

	switch (button) {
		case GLUT_RIGHT_BUTTON:
			break;
	} 
    return;
}

void gestionMenu(int value)
{
	switch (value) {
		case M_NONE:
			return;
		    break;
		case M_WIREFRAME : 
			WireFrame = !WireFrame;
			if (WireFrame) {
				glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
			} else {
				glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
			}
			break;
		case M_LUMIERE : 
			Lumiere = !Lumiere;
			if (Lumiere) {
				glDisable( GL_LIGHTING );
				glDisable( GL_LIGHT0 );
				glDisable(GL_COLOR_MATERIAL);
			} else {
				glEnable( GL_LIGHTING );
				glEnable( GL_LIGHT0 );
				glEnable(GL_COLOR_MATERIAL);
			}
			break;
		case M_BACKFACE :
			BackFace = !BackFace;
			if (BackFace) {
                glDisable(GL_CULL_FACE);
			} else {
	            glEnable(GL_CULL_FACE);
			}
			break;
	}
	glutPostRedisplay();
}

void createMenu() 
{
  glutCreateMenu(gestionMenu);
  glutAddMenuEntry("-------- Rendu --------", M_NONE);
  glutAddMenuEntry("WireFrame", M_WIREFRAME);
  glutAddMenuEntry("Lumiere", M_LUMIERE);
  glutAddMenuEntry("Faces caches", M_BACKFACE);
  glutAddMenuEntry("-----------------------", M_NONE);
  glutAttachMenu(GLUT_RIGHT_BUTTON);
}

void CreateTexture(UINT textureArray[], LPSTR strFileName, int textureID)
{
	AUX_RGBImageRec *pBitmap = NULL;
	
	if(!strFileName)									// Return from the function if no file name was passed in
		return;

	pBitmap = auxDIBImageLoad(strFileName);				// Load the bitmap and store the data
	
	if(pBitmap == NULL)									// If we can't load the file, quit!
		exit(0);

	// Generate a texture with the associative texture ID stored in the array
	glGenTextures(1, &textureArray[textureID]);

	// This sets the alignment requirements for the start of each pixel row in memory.
	glPixelStorei (GL_UNPACK_ALIGNMENT, 1);

	// Bind the texture to the texture arrays index and init the texture
	glBindTexture(GL_TEXTURE_2D, textureArray[textureID]);

	// Build Mipmaps (builds different versions of the picture for distances - looks better)
	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, pBitmap->sizeX, pBitmap->sizeY, GL_RGB, GL_UNSIGNED_BYTE, pBitmap->data);

	// Lastly, we need to tell OpenGL the quality of our texture map.  GL_LINEAR is the smoothest.
	// GL_NEAREST is faster than GL_LINEAR, but looks blochy and pixelated.  Good for slower computers though.
	// Read more about the MIN and MAG filters at the bottom of main.cpp
		
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	

	// Now we need to free the bitmap data that we loaded since openGL stored it as a texture

	if (pBitmap)										// If we loaded the bitmap
	{
		if (pBitmap->data)								// If there is texture data
		{
			free(pBitmap->data);						// Free the texture data, we don't need it anymore
		}

		free(pBitmap);									// Free the bitmap structure
	}
}

void reshape(int w, int h)
{
	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f,(GLfloat)w/(GLfloat)h, .5f ,150.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void idle (void)
{

  /* Update  state variables */
  time += TIME_STEP;

  /* Update main and sub window */
  glutSetWindow (winIdMain);
  glutPostRedisplay ();
  glutSetWindow (winIdSub);
  glutPostRedisplay ();
};

/* Callback function for reshaping the subwindow */
void drawString (char *s)
{
  unsigned int i;
  for (i = 0; i < strlen (s); i++)
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_10, s[i]);
};

void drawStringBig (char *s)
{
  unsigned int i;
  for (i = 0; i < strlen (s); i++)
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_18, s[i]);
};

void subReshape (int w, int h)
{
  glViewport (0, 0, w, h);
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  gluOrtho2D (0.0F, 1.0F, 0.0F, 1.0F);
};

void subDisplay ()
{

  /* Efface  la fenetre */
  glutSetWindow (winIdSub);
  glClearColor (0.25, 0.25, 0.25, 0.0);
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  /* Affiche les bords */
  glColor3f (0.0F, 1.0F, 0.0F);
  glBegin (GL_LINE_LOOP);
  glVertex2f (0.0F, 0.0F);
  glVertex2f (0.0F, 0.99F);
  glVertex2f (0.999F, 0.99F);
  glVertex2f (0.999F, 0.0F);
  glEnd ();

  /* Affiche les infos */
  glColor3f (1.0F, 0.0F, 1.0F);
  glRasterPos2f (0.3F, 0.92F);
  sprintf (label, " Angles ");
  drawStringBig (label);

  glColor3f (1.0F, 1.0F, 1.0F);

  /* Poignet */
  glRasterPos2f (0.05F, 0.85F);
  sprintf(label, "Poignet");
  drawString (label);
  glRasterPos2f (0.05F, 0.825F);
  sprintf(label, "X : %3.2f Y : %3.2f Z : %3.2f", g_3DModel.pObject[0].angle.x, g_3DModel.pObject[0].angle.y, g_3DModel.pObject[0].angle.z);
  drawString (label);

  /* Pouce */
  glRasterPos2f (0.05F, 0.775F);
  sprintf(label, "Pouce");
  drawString (label);
  glRasterPos2f (0.05F, 0.75F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[1].angle.x, g_3DModel.pObject[1].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.725F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[2].angle.x, g_3DModel.pObject[2].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.7F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[3].angle.x, g_3DModel.pObject[3].angle.y);
  drawString (label);

  /* Index */
  glRasterPos2f (0.05F, 0.65F);
  sprintf(label, "Index");
  drawString (label);
  glRasterPos2f (0.05F, 0.625F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[5].angle.x, g_3DModel.pObject[5].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.6F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[6].angle.x, g_3DModel.pObject[6].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.575F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[7].angle.x, g_3DModel.pObject[7].angle.y);
  drawString (label);

  /* Majeur */
  glRasterPos2f (0.05F, 0.525F);
  sprintf(label, "Majeur");
  drawString (label);
  glRasterPos2f (0.05F, 0.5F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[9].angle.x, g_3DModel.pObject[9].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.475F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[10].angle.x, g_3DModel.pObject[10].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.45F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[11].angle.x, g_3DModel.pObject[11].angle.y);
  drawString (label);

  /* Annulaire */
  glRasterPos2f (0.05F, 0.4F);
  sprintf(label, "Annulaire");
  drawString (label);
  glRasterPos2f (0.05F, 0.375F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[13].angle.x, g_3DModel.pObject[13].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.35F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[14].angle.x, g_3DModel.pObject[14].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.325F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[15].angle.x, g_3DModel.pObject[15].angle.y);
  drawString (label);

  /* Oriculaire */
  glRasterPos2f (0.05F, 0.275F);
  sprintf(label, "Oriculaire");
  drawString (label);
  glRasterPos2f (0.05F, 0.25F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[17].angle.x, g_3DModel.pObject[17].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.225F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[18].angle.x, g_3DModel.pObject[18].angle.y);
  drawString (label);
  glRasterPos2f (0.05F, 0.2F);
  sprintf(label, "X : %3.2f Y : %3.2f", g_3DModel.pObject[19].angle.x, g_3DModel.pObject[19].angle.y);
  drawString (label);

  glutSwapBuffers ();
};


DLLGFX_API void Hand(void)
{
	/* initialisation de glut et creation de la fenetre */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);
	glutInitWindowPosition(100,100);
	winIdMain = glutCreateWindow("TPED2002 GFX (c)2002 ESIEA");

	/* chargement de l'objet opengl */
	Init();

	/* Initialisation d'OpenGL */
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);
	glEnable(GL_DEPTH_TEST);

	glEnable(GL_LIGHT0);		
	glEnable(GL_LIGHTING);		
	glEnable(GL_COLOR_MATERIAL);

	/* enregistrement des fonctions de rappel */
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(key);
	glutIdleFunc (idle);
	glutMouseFunc(clic_souris);

	createMenu();

	/* Sub window creation and setup */
    winIdSub = glutCreateSubWindow (winIdMain, 5, 5, 175, SCREEN_HEIGHT - 10);
    glutDisplayFunc (subDisplay);
    glutReshapeFunc (subReshape);

	/* Entree dans la boucle principale glut */
	glutMainLoop();


}

DLLGFX_API void SetAxe(float* AN) {

	g_3DModel.pObject[17].angle.x=AN[0];
	g_3DModel.pObject[18].angle.x=AN[1];
	g_3DModel.pObject[19].angle.x=AN[2];
	g_3DModel.pObject[13].angle.x=AN[3];
	g_3DModel.pObject[14].angle.x=AN[4];
	g_3DModel.pObject[15].angle.x=AN[5];
	g_3DModel.pObject[9].angle.x=AN[6];
	g_3DModel.pObject[10].angle.x=AN[7];
	g_3DModel.pObject[11].angle.x=AN[8];
	g_3DModel.pObject[5].angle.x=AN[9];
	g_3DModel.pObject[6].angle.x=AN[10];
	g_3DModel.pObject[7].angle.x=AN[11];
	g_3DModel.pObject[2].angle.y=AN[12];
	g_3DModel.pObject[3].angle.y=AN[13];
	g_3DModel.pObject[17].angle.y=AN[14];

}