
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the DLLGFX_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// DLLGFX_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef DLLGFX_EXPORTS
#define DLLGFX_API __declspec(dllexport)
#else
#define DLLGFX_API __declspec(dllimport)
#endif

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream>
#include <vector>
#include <gl\gl.h>										// Fichier d'entte OpenGL32 Library
#include <gl\glu.h>										// Fichier d'entte GLu32 Library
#include <gl\glaux.h>
#include <crtdbg.h>
using namespace std;

#define SCREEN_WIDTH 800								// taille de l'cran en pixels
#define SCREEN_HEIGHT 600								// taille de l'cran en pixels
#define SCREEN_DEPTH 16									// Avec un codage des pixels sur 16 bits


// Dfinition des variables pernettant de stocker les informations sur
// les objets contenues dans un fichier .3DS
// permet de stocker qu'un seul fichier

#define MAX_TEXTURES 100

// Dfinition d'une classe vecteur pour stocker les coordonnes du point en trois dimension
class CVector3 
{
public:
	float x, y, z;
};

// Dfinition d'un vecteur 2D pour stocker un point
class CVector2 
{
public:
	float x, y;
};

//On dfinit ci-dessous une structure pour dfinir notre face. Elle est
//Utilis pour index  quel objet elle appartient et la texture associ. De ces informations
//Nous savons ansi ce que fait cette face
struct tFace
{
	int vertIndex[3];			// Indices du triangle
	int coordIndex[3];			// Indices du numro de texture
};

// Structure dfinissant le matriel utiliser pour dfinit l'objet
struct tMaterialInfo
{
	char  strName[255];			// Nom de la texture
	char  strFile[255];			// Nom de du fichier de texture
	BYTE  color[3];				// Couleur de l'objet (R, G, B)
	int   texureId;				// Texture ID
	float uTile;				// Pas utiliser
	float vTile;				// Pas utiliser
	float uOffset;			    // Pas utiliser
	float vOffset;				// Pas utiliser
} ;

//Structure dfinie pour stocker les objets du fichier
struct t3DObject 
{
	CVector3 angle;				// Angle de l'objet par rapport  sa position d'orgine
	CVector3 translate;			// Translation de l'objet pour modifier le repere
	int  numOfVerts;			
	int  numOfFaces;			
	int  numTexVertex;			
	int  materialID;			
	bool bHasTexture;			
	char strName[255];			
	CVector3  *pVerts;
	CVector3  *pNormals;		
	CVector2  *pTexVerts;		
	tFace *pFaces;				
};

//Strucuture dfinie pour stocker le nombre d'lements contenue dans le fichier
struct t3DModel 
{
	int numOfObjects;					
	int numOfMaterials;					
	vector<tMaterialInfo> pMaterials;	
	vector<t3DObject> pObject;			
};

void CreateTexture(UINT textureArray[], LPSTR strFileName, int textureID);
void Init();
void display();
void reshape();
void idle();
void key(unsigned char Key, int x, int y);
void clic_souris (int button, int state, int x, int y);
void createMenu();

void drawString (char *s);
void drawStringBig (char *s);

// Fonction extern pour affichage de la main3D
DLLGFX_API void Hand();
DLLGFX_API void SetAxe(float* AN);