// DGManagerDlg.h : header file
//
//{{AFX_INCLUDES()
#include "msflexgrid.h"
//}}AFX_INCLUDES

#if !defined(AFX_DGMANAGERDLG_H__13843D8B_6B0C_4AC2_9B5F_FC6A881D18F8__INCLUDED_)
#define AFX_DGMANAGERDLG_H__13843D8B_6B0C_4AC2_9B5F_FC6A881D18F8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "graph.h"
#include "DlgCalibrate.h"
#include "Calibrate.h"
#include "DlgEtalonnage.h"

/////////////////////////////////////////////////////////////////////////////
// CDGManagerDlg dialog

class CDGManagerDlg : public CDialog
{
// Construction
public:
	CDGManagerDlg(CWnd* pParent = NULL);	// standard constructor
	void SendAxe(); // fonction permettant le calcul des axes et l'envoie  la DLL
	int Convert(int Axe); // Fonction qui convertit l'entre utilisateur en entre analogique

// Dialog Data
	//{{AFX_DATA(CDGManagerDlg)
	enum { IDD = IDD_DGMANAGER_DIALOG };
	CButton	m_GoButton;
	CString	m_AN1;
	CString	m_AN2;
	CString	m_AN3;
	CString	m_AN4;
	CString	m_AN5;
	CString	m_AN6;
	CString	m_AN10;
	CString	m_AN11;
	CString	m_AN12;
	CString	m_AN7;
	CString	m_AN8;
	CString	m_AN9;
	CString	m_AN13;
	CString	m_AN14;
	CString	m_AN15;
	CString	m_AN17;
	CString	m_AN16;
	CString	m_AN18;
	CString	m_AN19;
	CString	m_AN20;
	CString	m_AN21;
	CString	m_AN22;
	CString	m_AN23;
	CString	m_AN24;
	CString	m_VEchelle;
	int		m_Canaux;
	CString	m_debit;
	CString	m_Fps;
	CString	m_Freq;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDGManagerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

public:
	int m_Echelle_min; // Dpart de l'chelle
	int m_Echelle_max; // fin de l'chelle
	
	CSliderCtrl m_Echelle; // Control de dfilment d'chelle
	int m_Amplitude;

	// Font pour crire sur le graphique
	CFont font;

	// Variable de status
	bool go; // vrai qd il trace la courbe
	long Timer; // temps d'acquisition
	bool connected; // vrai si on est connect
	bool m_StatCalibrate; // vrai si on est en train de calibrer
	bool m_View3D;	// vrai si la main 3D est visible
	bool m_P1;		// vrai si on prend en compte l'cartement des doigts

	// Variable pour stocker et dessiner le tableau
	int tabl[100000]; // tableau contenant les valeurs
	char Canal;  // pointeur sur le tableau
	CGraph m_pDisplay;
	bool m_raw_data;	// variable de reprsentation du graphe
	bool m_scaled_data;
	bool m_calibrate_data;
	bool m_scope;

	// Variable concernant la barre de status
	long m_IDebit;	// mesure le dbit de la transmition
	int m_Ifps;		// mesure du nombrre d'acquisition par seconde
	int m_IFreq;	// frequence de renouvellement de toute les valeurs
	
	// Variable pour la calibration
	CDlgCalibrate m_DlgCalibrate;
	CCalibrate m_Param[15];
	CDlgEtalonnage m_Etalonnage;
	int Pos; // Position de la barre de progression

	//Variable pour la main 3D
	float m_Hand[15];

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDGManagerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAbout();
	afx_msg void OnFichierQuitter();
	afx_msg void OnGloveConnect();
	afx_msg void OnAffichageOptions();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGo();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSelchangeCombo1();
	afx_msg void OnFichierEnregistrerlog();
	afx_msg void OnGloveCalibrate();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnGloveConfig();
	afx_msg void OnGloveMain3d();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DGMANAGERDLG_H__13843D8B_6B0C_4AC2_9B5F_FC6A881D18F8__INCLUDED_)
