// Graph.cpp : implementation file
//

#include "stdafx.h"
#include "DGManager.h"
#include "DGManagerDlg.h"
#include "Graph.h"
#include <gl/gl.h>
#include <gl/glu.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraph

CGraph::CGraph()
{
	// Initialisation de variable
	inc=0;
}

CGraph::~CGraph()
{
}


BEGIN_MESSAGE_MAP(CGraph, CWnd)
	//{{AFX_MSG_MAP(CGraph)
	ON_WM_CREATE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////

int MySetPixelFormat(HDC hdc)
{
	PIXELFORMATDESCRIPTOR pfd = { 
	    sizeof(PIXELFORMATDESCRIPTOR),    // size of this pfd 
	    1,                                // version number 
	    PFD_DRAW_TO_WINDOW |              // support window 
	    PFD_SUPPORT_OPENGL |              // support OpenGL 
	    PFD_DOUBLEBUFFER,                 // double buffered 
	    PFD_TYPE_RGBA,                    // RGBA type 
	    24,                               // 24-bit color depth 
	    0, 0, 0, 0, 0, 0,                 // color bits ignored 
	    0,                                // no alpha buffer 
	    0,                                // shift bit ignored 
	    0,                                // no accumulation buffer 
	    0, 0, 0, 0,                       // accum bits ignored 
	    32,                               // 32-bit z-buffer     
	    0,                                // no stencil buffer 
	    0,                                // no auxiliary buffer 
	    PFD_MAIN_PLANE,                   // main layer 
	    0,                                // reserved 
	    0, 0, 0                           // layer masks ignored 
	}; 
	
	int  iPixelFormat; 
 
	// get the device context's best, available pixel format match 
	if((iPixelFormat = ChoosePixelFormat(hdc, &pfd)) == 0)
	{
		MessageBox(NULL, "ChoosePixelFormat Failed", NULL, MB_OK);
		return 0;
	}
	 
	// make that match the device context's current pixel format 
	if(SetPixelFormat(hdc, iPixelFormat, &pfd) == FALSE)
	{
		MessageBox(NULL, "SetPixelFormat Failed", NULL, MB_OK);
		return 0;
	}

	return 1;
}
/////////////////////////////////////////////////////////////////////////////

int CGraph::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	MySetPixelFormat(::GetDC(m_hWnd));	

	return 0;
}

void CGraph::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	HDC hdc = ::GetDC(m_hWnd);
	HGLRC hglrc;

	// TODO: Add your message handler code here
	glClearColor(0,0,0,0);
	glColor3f(1, 1, 1);

	if (hglrc = wglCreateContext(hdc))
	{ 
        // try to make it the thread's current rendering context 
        if(wglMakeCurrent(hdc, hglrc))
		{
 			//render here
			glClear(GL_COLOR_BUFFER_BIT);
			//glEnable (GL_LINE_SMOOTH); // Anti aliasing
			glEnable (GL_LINE_STIPPLE); // Active la gestion de motif

			// Affichage de la grille
			glPushAttrib (GL_LINE_BIT);
			glLineStipple (3, 0xAAAA); // Dfinition du motif
			for(int i=0;i<10;i++) {
				glBegin(GL_LINES);
					glColor3f(1, 1, 1);
					glVertex3f((float)(10-2*i)/10, 1, 0);
					glVertex3f((float)(10-2*i)/10, -1, 0);
				glEnd();
			}
			
			for(i=0;i<10;i++) {
				glBegin(GL_LINES);
					glColor3f(1, 1, 1);
					glVertex3f(1,(float)(10-2*i)/10, 0);
					glVertex3f(-1,(float)(10-2*i)/10, 0);
				glEnd();
			}
			glPopAttrib();
			

			// Dessin du graph

			// Rcupre un pointeur sur la fentre parent
			CDGManagerDlg *pWnd= (CDGManagerDlg*)GetParent();

			// Est ce un pointeur valide
			if (pWnd) {
				//if(pWnd->go==true) {
					
					// Rcupre des paramtres
					int m_Echelle=pWnd->m_Echelle.GetPos();
					int m_Amplitude=pWnd->m_Amplitude;
					long m_Timer=pWnd->Timer;
				
					glColor3f(0, 0, 1); // Colueru bleu
					
					// Dessin du graphic
					glBegin(GL_LINE_STRIP);
						for(i=1;i<m_Timer;i++)
							glVertex2f((float)(-1000+(1000.0f/(m_Echelle/20)*5)*i)/1000,(float)(-1000.0f+2*(1000.0f/m_Amplitude)*pWnd->tabl[i])/1000.0f);

					glEnd();
				}

			SwapBuffers(hdc);
        } 
    }  

	wglMakeCurrent(NULL, NULL) ; 
	::ReleaseDC (m_hWnd, hdc) ; 
	wglDeleteContext(hglrc); 

	
	// Do not call CWnd::OnPaint() for painting messages
}
